首页 > 代码库 > BFS HDU 1175

BFS HDU 1175

哭,水题啊。开始的时候还以为很难的。看了题解发现好多人都是用DFS。我是用BFS 的,跟1728比较像。

思路就是。一个方向搜到底。但是要注意的是有棋子的地方是不能经过的。

 

代码虐我千百遍,我待代码如初恋微笑

 

 

 

 

连连看

Time Limit: 20000/10000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 18770    Accepted Submission(s): 4895


Problem Description
“连连看”相信很多人都玩过。没玩过也没关系,下面我给大家介绍一下游戏规则:在一个棋盘中,放了很多的棋子。如果某两个相同的棋子,可以通过一条线连起来(这条线不能经过其它棋子),而且线的转折次数不超过两次,那么这两个棋子就可以在棋盘上消去。不好意思,由于我以前没有玩过连连看,咨询了同学的意见,连线不能从外面绕过去的,但事实上这是错的。现在已经酿成大祸,就只能将错就错了,连线不能从外围绕过。
玩家鼠标先后点击两块棋子,试图将他们消去,然后游戏的后台判断这两个方格能不能消去。现在你的任务就是写这个后台程序。


 

Input
输入数据有多组。每组数据的第一行有两个正整数n,m(0<n<=1000,0<m<1000),分别表示棋盘的行数与列数。在接下来的n行中,每行有m个非负整数描述棋盘的方格分布。0表示这个位置没有棋子,正整数表示棋子的类型。接下来的一行是一个正整数q(0<q<50),表示下面有q次询问。在接下来的q行里,每行有四个正整数x1,y1,x2,y2,表示询问第x1行y1列的棋子与第x2行y2列的棋子能不能消去。n=0,m=0时,输入结束。
注意:询问之间无先后关系,都是针对当前状态的!


 

Output
每一组输入数据对应一行输出。如果能消去则输出"YES",不能则输出"NO"。


 

Sample Input
3 4 1 2 3 4 0 0 0 0 4 3 2 1 4 1 1 3 4 1 1 2 4 1 1 3 3 2 1 2 4 3 4 0 1 4 3 0 2 4 1 0 0 0 0 2 1 1 2 4 1 3 2 3 0 0


 

Sample Output
YES NO NO NO NO YES
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <limits.h>
#include <ctype.h>
#include <string.h>
#include <string>
#include <math.h>
#include <algorithm>
#include <iostream>
#include <queue>
#include <stack>
#include <deque>
#include <vector>
#include <set>
using namespace std;
#define MAXN 1000 + 10
int num[MAXN][MAXN];
int vis[MAXN][MAXN];
int n,m;
int fx,fy;
int xx[4]={-1,0,1,0};
int yy[4]={0,1,0,-1};

struct node{
    int x;
    int y;
    int count;
};

void BFS(int a,int b){
    queue<node>q;
    node front;
    int i;
    node rear;
    front.x = a;
    front.y = b;
    front.count = -1;
    q.push(front);
    int mark = 0;
    while(!q.empty()){
        front = q.front();
        q.pop();
        if(front.x==fx && front.y==fy){
            if(front.count <= 2){
                printf("YES\n");
                mark = 1;
                break;
            }
            else{
                printf("NO\n");
                mark = 1;
                break;
            }
        }
        rear.count = front.count + 1;
        for(i=0;i<4;i++){
            int dx = front.x + xx[i];
            int dy = front.y + yy[i];
            while((dx>=0&&dx<n&&dy>=0&&dy<m&&num[dx][dy]==0) || (dx>=0&&dx<n&&dy>=0&&dy<m&&dx==fx&&dy==fy)){
                if(vis[dx][dy] == 0){
                    vis[dx][dy] = 1;
                    rear.x = dx;
                    rear.y = dy;
                    q.push(rear);
                }
                dx = dx + xx[i];
                dy = dy + yy[i];
             }
        }
    }
    if(mark == 0){
        printf("NO\n");
    }
}

int main(){
    int i,j;
    int k;
    int x1,y1,x2,y2;

    while(~scanf("%d%d",&n,&m)){
        if(n==0 && m==0){
            break;
        }
        memset(num,0,sizeof(num));
        memset(vis,0,sizeof(vis));
        for(i=0;i<n;i++){
            for(j=0;j<m;j++){
                scanf("%d",&num[i][j]);
            }
        }
        if(n==1 && m==1){
            printf("NO\n");
            continue;
        }
        scanf("%d",&k);
        while(k--){
            scanf("%d%d%d%d",&x1,&y1,&x2,&y2);
            memset(vis,0,sizeof(vis));
            vis[x1-1][y1-1] = 1;
            fx = x2-1;
            fy = y2-1;
            if(num[x1-1][y1-1] != num[x2-1][y2-1]){
                printf("NO\n");
                continue;
            }
            else if(num[x1-1][y1-1]==num[x2-1][y2-1] && num[x1-1][y1-1]==0){
                printf("NO\n");
                continue;
            }
            else{
                BFS(x1-1,y1-1);
            }
            //BFS(x1-1,y1-1);
        }
    }

    return 0;
}


 

BFS HDU 1175